# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class Redirect(UniversalBaseModel):
    """
    A single redirection rule, specifying a source URL and a destination URL.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the specific redirect rule
    """

    from_url: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="fromUrl")] = pydantic.Field(
        default=None
    )
    """
    The source URL path that will be redirected.
    """

    to_url: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="toUrl")] = pydantic.Field(
        default=None
    )
    """
    The target URL path where the user or client will be redirected.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
