# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
from .script_apply_location import ScriptApplyLocation
import typing
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ScriptApply(UniversalBaseModel):
    id: str = pydantic.Field()
    """
    ID of the registered custom code script
    """

    location: ScriptApplyLocation = pydantic.Field()
    """
    Location of the script, either in the header or footer of the published site
    """

    version: str = pydantic.Field()
    """
    Semantic Version String for the registered script *e.g. 0.0.1*
    """

    attributes: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = pydantic.Field(default=None)
    """
    Developer-specified key/value pairs to be applied as attributes to the script
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
